#ifndef BALL_H
#define BALL_H

using namespace std;

class BALL{
public:
	float x,y,xs,ys;	//Position and speed
	int flags;	//properties of the ball

	BALL(float ix,float iy,float ixs,float iys,int iflags);
	bool update();	//Returns false if dead
	void edit(float ix,float iy,float ixs,float iys,int iflags);
	void draw(BITMAP *buffer, int r, int g, int b, int (*project)(float *f, int *i, int c));
};

void split_balls();
void slow_balls();
void update_balls();
void draw_balls(BITMAP *buffer, int r, int g, int b, int (*project)(float *f, int *i, int c));

extern list<BALL> balls;

#endif
 
