#include<list>
using namespace std;
#include<allegro.h>

#include"main.h"

#include"ball.h"
#include"block.h"
#include"droid.h"
#include"player.h"
#include"view.h"
#include"ganja.h"
#include"item.h"
#include"particles.h"
#include"message.h"

int play_time=0;
void _play_time(){play_time++;}END_OF_FUNCTION(_play_time);
bool kep=0;



int play_game(BITMAP *buffer){
	init_players();
	init_ganjas();
	init_items();
	init_view();
	level=0;
	plant_ganjas();

	LOCK_VARIABLE(play_time);
	LOCK_FUNCTION(_play_time);
	install_int_ex(_play_time,BPS_TO_TIMER(60));

	score=0;
	int ldr=0;	//Last Droid Release
	bool pause=0,kpp=0;
	int gameover=0,d;
	play_time=0;

	int time_count=0,frame_count=0;
	int fps=0;

	next_level();
	while(!gameover &&!key[KEY_ESC]){
		poll_keyboard();
		if(key[KEY_P] && !kpp){
			kpp=1;
			pause=!pause;
		}
		if(!key[KEY_P] && kpp)	kpp=0;
		if(pause){
			play_time=0;
			get_mouse_mickeys(&d,&d);
		}
		ldr+=play_time;
		if(ldr>600){	//Droids release every ten secs, 60*10
			ldr=0;
			if(droids.size()<3)
				droids.push_back(DROID( (rand()%100)/100.0 ,1,.0005*(rand()%3-1),-.004));
		}
		while(play_time && !key[KEY_ESC]){
			time_count++;
			play_time--;
			update_view();
			gameover=update_ganjas();
			//These are updated after ganjas so they are removed if they are eliminated in ganja update. Undoes unnecessary execution when drawn.
			update_droids();
			update_balls();
			update_players();
			update_items();
			update_message();
			update_particles();
			if(!update_blocks() || (cheat && key[KEY_ENTER] && !kep)){
				kep=1;
				next_level();
				advance_view();
				//This doesn't eliminate the balls functionality.
				//It only deletes all created balls and leaves us with the NULLed pointer from init_balls();
				balls.clear();
				items.clear();
				droids.clear();
			}
			if(!key[KEY_ENTER])	kep=0;

			if(time_count>=60){
				fps=frame_count;
				frame_count=0;
				time_count=0;
			}
		}
		//Take a screenshot
		if (key[KEY_PRTSCR]) {
			static int ss_count = 0;
			char fname[80];
			PALETTE pal;

			sprintf(fname, "dump%03d.tga", ++ss_count);
			get_palette(pal);
			save_tga(fname, buffer, pal);
			while (key[KEY_PRTSCR])
				poll_keyboard();
		}
		clear(buffer);
		draw_view(buffer);
		frame_count++;
		textprintf(buffer,font,0,0,makecol(255,255,255),"%i",fps);
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}

	shutdown_players();
	balls.clear();
	blocks.clear();
	droids.clear();
	msgs.clear();
	items.clear();
	particles.clear();
	shutdown_view();
	kep=0;
	remove_int(_play_time);
	return gameover;
}
 
