#ifndef BLOCK_H
#define BLOCK_H

using namespace std;

class BLOCK{
public:
	double x,y;	//Position
	int strength;	//How many hits can it take
	int color;		//I might want to make this thing pretty

	BLOCK(double x,double y,int strength,int color);
	bool update();
	bool contains(double cx,double cy);
	void draw(BITMAP *buffer, int r, int g, int b, int (*project)(float *f, int *i, int c));
};
void soft_blocks();
int update_blocks();
void draw_blocks(BITMAP *buffer, int r, int g, int b, int (*project)(float *f, int *i, int c));
void next_level();

extern list<BLOCK> blocks;
extern int level;

#endif
 
