#include<allegro.h>
#include<aldumb.h>

#include"main.h"

#include"func.h"
#include"hiscore.h"
#include"mouse.h"

#include"editor.h"

int m_tid=0;
void _m_tid(){m_tid++;}
int m_lut=0;


void scroller(BITMAP *buffer,char *scroll,int &scrollprogress,int y);


int menus(){
	DUH *myduh = dumb_load_mod("menu.mod");
	AL_DUH_PLAYER *dp=al_start_duh(myduh, 2, 0,.5f, 4096, 44100);


	install_int_ex(_m_tid,BPS_TO_TIMER(60));
	char scroll[]="Welcome to Miffonoid!   This game is made by Anders Andersson aka Trezker/Dumle/Martuk 2002.   This is the first game I have ever made complete!   At first it was supposed to become a simple arkanoid lookalike.   But I got a vision, and then it rolled on all the way here.   Mail me if you want.   Live long and prosper!   ";
	char credits[]="There are always some people to thank, and here's my list for this game.   Herman Hedning for the term Miffo   Shawn Hargreaves, who made about 99% of the game since I used his creation Allegro and code from his game SPEED.   Allegro community, for being the best community in the world.   Greetings to: Lars Lindblad, Fredrik Bckman, Fredrik Johansson, my family and the rest of my friends.   Thanks to the hundreds of musical artists who kept me happy, I have almost every song from www.tump.net pre feb 2003 :)   A big thanks go to a DUMB programmer who enables me to use mods in the game.   Finally a thank you to all I forgot.   ";
	char instructions[]="You can drag these scrollers with Right mouse button.   How to play this game:   Mouse moves pad.   Left mouse button releases balls.   Right mouse button catches balls if you have the C powerup.   G releases ganja seed if one is hanging on the pad.   F fires weapon if you have the W powerup.   ";
	int scrollprogress[3]={0,0,0};
	int mx,my,ty,oy=0;

	init_mouse();
	clear(screen);
	BITMAP *bmp=load_bitmap("menudump1.tga",NULL);
	BITMAP *buffer=create_bitmap(SCREEN_W,SCREEN_H);

	BITMAP *mn_bmp=create_bitmap(72,8);
	clear_bitmap(mn_bmp);
	textprintf(mn_bmp,font,0,0,makecol(134,56,113),"MIFFONOID");

	while(key[KEY_ESC] || key[KEY_SPACE])
		poll_keyboard();

	while(!key[KEY_ESC]){
	if(m_tid-m_lut){
		m_lut=m_tid;
		al_poll_duh(dp);
		poll_keyboard();
		update_mouse();
		get_mouse_mickeys(&mx,&my);


		//Tell the player what this shit is.
		stretch_blit(mn_bmp,buffer,0,0,mn_bmp->w,mn_bmp->h,0,0,SCREEN_W,SCREEN_H/4);

		//Scrollers
		if(mouse_d&2)	oy=mouse_y;
		if(mouse_b&2){
			if(mouse_y>SCREEN_H/4 && mouse_y<SCREEN_H/4+30){
				ty=(mouse_y-SCREEN_H/4)/10;
				scrollprogress[ty]-=mx+1;
				position_mouse(mouse_x,oy);
			}
		}

		scroller(buffer,scroll,scrollprogress[0],SCREEN_H/4);
		scroller(buffer,credits,scrollprogress[1],SCREEN_H/4+10);
		scroller(buffer,instructions,scrollprogress[2],SCREEN_H/4+20);

		//Start
		if(mouse_over(SCREEN_W/8,SCREEN_H/5*2, SCREEN_W/8+6*8,SCREEN_H/5*2+8)){
			textprintf(buffer,font,SCREEN_W/8,SCREEN_H/5*2,makecol(234,216,213),"START!");
			if(mouse_u&1)
				break;
		}
		else
			textprintf(buffer,font,SCREEN_W/8,SCREEN_H/5*2,makecol(234,116,113),"START!");



		{	//Textures
			static int state=0;
			static int swish=0;
			int color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2 , SCREEN_W , SCREEN_H/2+8 ) ){
				color=makecol(234,216,213);
				if( state==0 && mouse_u&1 )
					state++;
			}
			if(state==1){
				swish+=5;
				if(swish>196){
					state++;
					textures=!textures;
				}
			}
			if(state==2){
				swish-=5;
				if(swish==0)
					state=0;
			}

			if(textures)
				textprintf(buffer,font,SCREEN_W-128+swish,SCREEN_H/2,color,"Textures on");
			else
				textprintf(buffer,font,SCREEN_W-128+swish,SCREEN_H/2,color,"Textures off");
		}


			int color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+10 , SCREEN_W , SCREEN_H/2+18 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 )
					score_table();
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+10,color,"Hiscore table");


			color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+20 , SCREEN_W , SCREEN_H/2+28 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 )
					editor(buffer);
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+20,color,"Level edit");

			color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+30 , SCREEN_W , SCREEN_H/2+38 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 ){
					//cpn_edit();
				}
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+30,color,"Campaign edit");

			color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+50 , SCREEN_W , SCREEN_H/2+58 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 ){
					gamemode=0;
				}
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+50,color,"Default campaign");

			color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+60 , SCREEN_W , SCREEN_H/2+68 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 ){
					load_level();
					gamemode=1;
				}
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+60,color,"Single level");

			color=makecol(234,116,113);
			if( mouse_over( SCREEN_W-128 , SCREEN_H/2+70 , SCREEN_W , SCREEN_H/2+78 ) ){
				color=makecol(234,216,213);
				if(mouse_u&1 ){
					//load_campaign();
					//gamemode=2;
				}
			}
			textprintf(buffer,font,SCREEN_W-128,SCREEN_H/2+70,color,"Campaign");


		//View selection
		stretch_blit(bmp,buffer,0,0,bmp->w,bmp->h,0,SCREEN_H/2,SCREEN_W/2,SCREEN_H/2);

		if(viewmode==0)
			rect(buffer,0,SCREEN_H/2,SCREEN_W/4,SCREEN_H/4*3,makecol(200,200,200));
		if(viewmode==1)
			rect(buffer,SCREEN_W/4,SCREEN_H/2,SCREEN_W/2,SCREEN_H/4*3,makecol(200,200,200));
		if(viewmode==2)
			rect(buffer,0,SCREEN_H/4*3,SCREEN_W/4,SCREEN_H-1,makecol(200,200,200));
		if(viewmode==3)
			rect(buffer,SCREEN_W/4,SCREEN_H/4*3,SCREEN_W/2,SCREEN_H-1,makecol(200,200,200));

		if(mouse_over(0,SCREEN_H/2,SCREEN_W/4,SCREEN_H/4*3)){
			textprintf(buffer,font,mouse_x+8,mouse_y-8,makecol(200,200,200),"Flat");
			if(mouse_u&1)
				viewmode=0;
		}
		if(mouse_over(SCREEN_W/4,SCREEN_H/2,SCREEN_W/2,SCREEN_H/4*3)){
			textprintf(buffer,font,mouse_x+8,mouse_y-8,makecol(200,200,200),"Spherical coords");
			if(mouse_u&1)
				viewmode=1;
		}
		if(mouse_over(0,SCREEN_H/4*3,SCREEN_W/4,SCREEN_H)){
			textprintf(buffer,font,mouse_x+8,mouse_y-8,makecol(200,200,200),"Inside tube");
			if(mouse_u&1)
				viewmode=2;
		}
		if(mouse_over(SCREEN_W/4,SCREEN_H/4*3,SCREEN_W/2,SCREEN_H)){
			textprintf(buffer,font,mouse_x+8,mouse_y-8,makecol(200,200,200),"Outside cylinder");
			if(mouse_u&1)
				viewmode=3;
		}


		show_mouse(buffer);
		blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		show_mouse(NULL);
		clear_bitmap(buffer);
	}
	}
	al_stop_duh(dp);
	unload_duh(myduh);

	if(key[KEY_ESC])
		return FALSE;
	else
		return TRUE;
}



void scroller(BITMAP *buffer,char *scroll,int &scrollprogress,int y){
	int x=-8-scrollprogress%8,i;

	for(int j=0;j<=SCREEN_W/8;j++){
		i=(j+scrollprogress/8)%strlen(scroll);
		x+=8;
		textprintf(buffer,font,x,y,makecol(124,232,231),"%c",scroll[i]);
	}

	scrollprogress+=1;
	scrollprogress%=(strlen(scroll)*8);
}
 
