#include<allegro.h>


#include"mouse.h"

void correct_rect(int x1,int y1,int x2,int y2,int *xs,int *ys,int *xe,int *ye){
	*xs=x1<x2?x1:x2;
	*xe=x1>x2?x1:x2;
	*ys=y1<y2?y1:y2;
	*ye=y1>y2?y1:y2;
}



int mouseb_previous,mouse_u, mouse_d;
//Two sets since the user might update before checking mouse_enter and such...
int x,y,ox,oy;

void init_mouse(){
	mouseb_previous=0;
	mouse_d=0;
	mouse_u=0;
	x=mouse_x;
	y=mouse_y;
}



void update_mouse(){
	mouse_d=0;mouse_u=0;

	mouse_d=(mouseb_previous^mouse_b)&mouse_b;
	mouse_u=(mouseb_previous^mouse_b)&(mouse_b^7);
	mouseb_previous=mouse_b;

	ox=x;
	oy=y;
	x=mouse_x;
	y=mouse_y;
}



bool mouse_over(int x1,int y1,int x2,int y2){
	int xs,xe,ys,ye;
	correct_rect(x1,y1,x2,y2,&xs,&ys,&xe,&ye);
	if(xs<=mouse_x && xe>=mouse_x && ys<=mouse_y && ye>=mouse_y)
		return 1;
	return 0;
}



bool new_over(int x1,int y1,int x2,int y2){
	int xs,xe,ys,ye;
	correct_rect(x1,y1,x2,y2,&xs,&ys,&xe,&ye);
	if(xs<=x && xe>x && ys<=y && ye>y)
		return 1;
	return 0;
}
bool old_over(int x1,int y1,int x2,int y2){
	int xs,xe,ys,ye;
	correct_rect(x1,y1,x2,y2,&xs,&ys,&xe,&ye);
	if(xs<=ox && xe>ox && ys<=oy && ye>oy)
		return 1;
	return 0;
}



bool mouse_enter(int x1,int y1,int x2,int y2){
	if(new_over(x1,y1,x2,y2) && !old_over(x1,y1,x2,y2))
		return 1;
	return 0;
}



bool mouse_leave(int x1,int y1,int x2,int y2){
	if(!new_over(x1,y1,x2,y2) && old_over(x1,y1,x2,y2))
		return 1;
	return 0;
} 
