#ifndef TMOUSE_H
#define TMOUSE_H
/*
	mousebup and mousebdown are used just like mouse_b
	They are updated when calling update_mouse

	The mouse_over function can be used without updating or initiating mouse since it only uses mouse_x and mouse_y.
	enter and leave can be called after update.
*/
extern int mouse_u, mouse_d;

void init_mouse();
void update_mouse();
bool mouse_over(int x1,int y1,int x2,int y2);
bool mouse_enter(int x1,int y1,int x2,int y2);
bool mouse_leave(int x1,int y1,int x2,int y2);
#endif 
